#ifndef __DUALIS_H__
#define __DUALIS_H__

// Windows Header Files:
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <winuser.h>

// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

#include "CEventQueue.h"
#include "CMenu.h"
#include "CScrollBar.h"

#include "ioregs.h"
#include "mspal.h"
#include "resource.h"
#include "zombie.h"


#define NUM_WINDOWS	15


typedef struct
{
	HWND hwnd;
	bool active;
} window;


extern HWND				hMain,hPropsheet,hMainChk,hSubChk,hMainScr,hSubScr,hStatus,hPalw,hDbgw,hMemw;
extern HWND				hScrollbar1,hScrollbar2,hComboMem;
extern HDC				paldc,dbgdc,memdc,disdc,iodc,twdc,mapdc,oamdc,texdc;
extern HFONT			font;
extern HANDLE			hOut;
extern HINSTANCE		hInst,hCPU,hCPUsub,hMMU,hGPU,hINP;
extern HACCEL			haccel;
extern PAINTSTRUCT		ps;
extern MSG				msg;
extern UINT				defaultFontID;
extern RECT				rect2;
extern unsigned int		*arm9_regs,*arm7_regs;
extern char				dbgMessages[32][64];
extern int				dbgMsgCount;
extern int				dbgMsgPos,memVPos;
extern SCROLLINFO		si,si2,si3,si4;
extern CScrollBar		memviewScroll,disasmScroll,debugScroll;
extern COLORREF			colors[8];
extern unsigned int		memview_lut[13];
extern cpu_get_callback cpu_get,cpu_sub_get;
extern cpu_set_callback cpu_set,cpu_sub_set;
extern mmu_get_callback mmu_get;
extern mmu_set_callback mmu_set;
extern mmu_read_word_callback mmu_read_word;
extern mmu_write_byte_callback mmu_write_byte;
extern mmu_write_word_callback mmu_write_word;
extern mmu_write_dword_callback mmu_write_dword;
extern gpu_get_callback gpu_get;
extern gpu_set_callback gpu_set;
extern int				palUpdateMode;
extern bool				romLoaded;
extern MSPAL			mspal;
extern SYSTEMTIME		systime;
extern int				ipcLoc,ipcFormat;
extern bool				openCon;
extern unsigned char	theme;
extern int				tsCalibX1,tsCalibY1,tsCalibX2,tsCalibY2;
extern char				iniFn[256];
extern unsigned short	tileData[64],objPlainData[64*64],objFinalData[128*128];
extern palette_dib		tile,objPlain,objFinal,*pdib;
extern window			windows[NUM_WINDOWS];
extern touchpad			touch;
extern char				**pageTable;
extern char				szBuffer[512],szFnBuffer[400],szBuffer3[256];
extern char				szFileNameOnly[400];
extern char				szPropsheetCaption[5][16];
extern int				propSheetButtons[];
extern DLGPROC			PageDlgProc[4];
extern int				renderer;
extern int				fpsLimit,frameskip;
extern int				mirrorIPC;
extern bool				run,quit;
extern unsigned int		arm9PluginVersion,mmuPluginVersion,gpuPluginVersion,inpPluginVersion,guiVersion;


extern void reset_machine(bool hard);
extern int get_openfilename(char *szBuf, char *szTitle, char *szFilter);
extern int get_savefilename(char *szBuf, char *szTitle, char *szFilter);


#endif
